/*

 Copyright (c) [2023] [pcm]
 [pcm-coordinator] is licensed under Mulan PSL v2.
 You can use this software according to the terms and conditions of the Mulan PSL v2.
 You may obtain a copy of Mulan PSL v2 at:
          http://license.coscl.org.cn/MulanPSL2
 THIS SOFTWARE IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OF ANY KIND,
 EITHER EXPaRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO NON-INFRINGEMENT,
 MERCHANTABILITY OR FIT FOR A PARTICULAR PURPOSE.
 See the Mulan PSL v2 for more details.

*/

package cloud

import (
	"context"
	"errors"
	"github.com/zeromicro/go-zero/core/logx"
	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/participant/cloud"
	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/svc"
	container "gitlink.org.cn/JointCloud/pcm-coordinator/internal/types/cloud"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/constants"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/models"
	cloud2 "gitlink.org.cn/JointCloud/pcm-coordinator/pkg/models/cloud"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/utils"
	"net/http"
	"strconv"
	"time"
)

type ContainerCreateLogic struct {
	logx.Logger
	ctx    context.Context
	svcCtx *svc.ServiceContext
}

func NewContainerCreateLogic(ctx context.Context, svcCtx *svc.ServiceContext) *ContainerCreateLogic {
	return &ContainerCreateLogic{
		Logger: logx.WithContext(ctx),
		ctx:    ctx,
		svcCtx: svcCtx,
	}
}

func (l *ContainerCreateLogic) ContainerCreate(req *container.CreateParam) (resp *ContainerCreateRespStruct, err error) {
	resp = &ContainerCreateRespStruct{}
	param := &cloud.CreateParam{
		Name:               req.Name,
		Description:        req.Description,
		Port:               req.Port,
		Cpu:                req.Cpu,
		Memory:             req.Memory,
		Image:              req.Image,
		Args:               req.Args,
		MountPath:          req.MountPath,
		Envs:               req.Envs,
		NodePort:           req.NodePort,
		ContainerGroupName: req.ContainerGroupName,
		CreateParameter:    req.ContainerCreateParameter,
	}
	create, err := l.svcCtx.Cloud.ContainerCreate(req.ClusterId, param)
	if err != nil {
		return nil, err
	}
	if create.Code != http.StatusOK {
		return nil, errors.New(create.Message)
	}
	// 构建主任务结构体
	taskModel := models.Task{
		Id:              utils.GenSnowflakeID(),
		Status:          constants.Saved,
		Description:     req.Description,
		Name:            req.Name,
		UserId:          req.UserId,
		AdapterTypeDict: "0",
		CommitTime:      time.Now(),
	}
	// 保存任务数据到数据库
	tx := l.svcCtx.DbEngin.Create(&taskModel)
	if tx.Error != nil {

	}
	var adapterId int64
	tx.Table("t_cluster").Select("adapter_id").Where("id=?", req.ClusterId).Find(&adapterId)
	// 构建cloud任务结构体
	cloudTaskModel := cloud2.TaskCloudModel{
		Id:        utils.GenSnowflakeID(),
		TaskId:    taskModel.Id,
		Name:      req.Name,
		AdapterId: adapterId,
		Status:    constants.Saved,
		Namespace: "default",
		UserId:    req.UserId,
	}
	// 保存任务数据到数据库
	tx = l.svcCtx.DbEngin.Create(&cloudTaskModel)
	if tx.Error != nil {

	}
	resp.TaskId = strconv.FormatInt(taskModel.Id, 10)
	return resp, nil
}

type ContainerCreateRespStruct struct {
	TaskId string `json:"taskId"`
}
